/*
	Rutoken Flash Mount Util

	LOGIN:
	00 20 00 01 08 38 37 36 35 34 33 32 31
	GET SD SIZE:
	80 53 12 00 04
	WRITE LUNs:
	80 53 10 00 0A 80 08 01 83 02 00 20 00 00 00 (LUN1 =   32mb, R/W)
	80 53 10 00 0A 81 08 02 83 02 0C 00 00 00 00 (LUN2 = 3072mb, R/W)
	RESTART:
	80 53 14 00
	>>>>WRITE ISO<<<<
	LOGIN USER:
	00 20 00 02 08 31 32 33 34 35 36 37 38
	LUN1 - CDROM:
	80 53 11 02 04 82 02 01 05
	LUN2 - HIDDEN:
	80 53 11 02 04 82 02 02 00 
	RESTART:
	80 53 14 00
	LOGOUT:
	80 40 00 00

	igorkov / 2016 / igorkov.org/tm2mount
 */

#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "scard.h"

BYTE password[128];

#define IDD_LOGIN      1000
#define IDC_PASSWORD   1001
#define IDC_BTN_OK     1002
#define IDC_BTN_HELP   1003
#define IDR_ICON_BIG   100
#define IDR_ICON_SMALL 101

#if defined(_DBGOUT)
#define DBG printf
#else
#define DBG(...)
#endif

BOOL APIENTRY login_proc(HWND hwndDlg, UINT message, UINT wParam, LONG lParam) {
	HWND hwndOwner;  
	RECT rc, rcDlg, rcOwner;
	HICON hIcon;
	char str[32];
	switch (message) {
	case WM_INITDIALOG:
		DBG("login_proc(): WM_INITDIALOG\r\n");
		//         .
		if ((hwndOwner = GetParent(hwndDlg)) == NULL) {
			hwndOwner = GetDesktopWindow(); 
		}
		GetWindowRect(hwndOwner, &rcOwner); 
		GetWindowRect(hwndDlg, &rcDlg); 
		CopyRect(&rc, &rcOwner); 
		//       ,
		//          
		// ,       ,
		//     .
		OffsetRect(&rcDlg, -rcDlg.left, -rcDlg.top); 
		OffsetRect(&rc, -rc.left, -rc.top); 
		OffsetRect(&rc, -rcDlg.right, -rcDlg.bottom); 
		//  ,  -    
		//      . 
		SetWindowPos(hwndDlg,HWND_TOP,rcOwner.left + (rc.right / 2), 
			rcOwner.top + (rc.bottom / 2), 
			0, 0,	//    
			SWP_NOSIZE);
#if 0
		if (GetDlgCtrlID((HWND)wParam) != ID_ITEMNAME) { 
			SetFocus(GetDlgItem(hwndDlg, ID_ITEMNAME));
			return FALSE;
		} 
#endif
		//  :
		hIcon = (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_ICON_BIG), IMAGE_ICON, 32, 32, 0);
		SendMessage(hwndDlg, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
		hIcon = (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_ICON_SMALL), IMAGE_ICON, 16, 16, 0);
		SendMessage(hwndDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
		return (TRUE);
#if 0
	case WM_KEYDOWN:
		DBG("login_proc(): WM_KEYDOWN\r\n");
		switch (wParam) {
		case VK_RETURN:
			DBG("login_proc(): WM_KEYDOWN > VK_RETURN\r\n");
			goto label_ok;
		case VK_ESCAPE:
			DBG("login_proc(): WM_KEYDOWN > VK_ESCAPE\r\n");
			goto label_end;
		}
		break;
#endif
	case WM_NOTIFY:
		DBG("login_proc(): WM_NOTIFY\r\n");
		break;
	case WM_COMMAND:
		DBG("login_proc(): message = %d, %08x %08x\r\n", message, wParam, lParam);
		if (LOWORD(wParam) == 0x0001) {
			DBG("login_proc(): WM_COMMAND > 0x01 (VK_RETURN)\r\n");
			goto label_ok;
		}
		if (LOWORD(wParam) == 0x0002) {
			DBG("login_proc(): WM_COMMAND > 0x02 (VK_ESCAPE)\r\n");
			goto label_end;
		}
		if (LOWORD(wParam) == IDC_BTN_OK) {
label_ok:
			GetDlgItemText(hwndDlg, IDC_PASSWORD, password, sizeof(password));
			EndDialog(hwndDlg, TRUE);
			return (TRUE);
		}
		if (LOWORD(wParam) == IDC_BTN_HELP) {
			ShellExecute(NULL, "open", "http://igorkov.org/tm2mount", NULL, NULL, SW_SHOW);
			return (FALSE);
		}
		break;
	case WM_SYSCOMMAND:
		if (wParam == SC_CLOSE) {
label_end:
			EndDialog(hwndDlg, IDCANCEL);
			return TRUE;
		}
		break;
	case WM_NCDESTROY:
		EndDialog(hwndDlg, TRUE);
		return (TRUE);
	}
	return (FALSE);
}

char *pabCartReadersNames[] = {
	"Aktiv Rutoken ECP 0",
	"Aktiv Rutoken ECP 1",
	"Aktiv Rutoken ECP 2",
	NULL,
};

int main(int argc, char **argv) {
	DWORD dwRet;
	HINSTANCE hInstance;
	HWND hWnd = NULL;
	BYTE abMessage[256];
	SCARDCONTEXT hContext = 0;
	SCARDHANDLE hSmartCard = 0;
	LPCSCARD_IO_REQUEST gpIOSendPCI;
	LPCSCARD_IO_REQUEST *pgpIOSendPCI = &gpIOSendPCI;
	DWORD dwActiveProtocol;
	
	// get instance
	hInstance = GetModuleHandle(NULL);
	// create dialog
	dwRet = DialogBox(hInstance, MAKEINTRESOURCE(IDD_LOGIN), hWnd, (DLGPROC)login_proc);
	if (dwRet == IDOK) {
		int i;

		BYTE pbyOutput[256+2];
		DWORD dwReplyLength = 0;
		DWORD dwTokenID;
		BYTE abTokenID[128];
		BYTE bFoundFlag = 0;

		// APDUs:
		BYTE pbyGetID[]  = { 0x00, 0xCA, 0x01, 0x81, 0x08 };
		BYTE pbyLogin[5+32]  = { 0x00, 0x20, 0x00, 0x02, 0x08, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38 };
		BYTE pbyLogout[] = { 0x80, 0x40, 0x00, 0x00 };
		BYTE pbyMount[]  = { 0x80, 0x53, 0x11, 0x01, 0x04, 0x82, 0x02, 0x02, 0x03 }; // LUN2

		// Get allow ID parameter:
		GetPrivateProfileString("ID","TOKEN_ID", "0", abTokenID, sizeof(abTokenID)-1, "./id.ini");
		if (GetLastError()) {
			DBG("INI-file \"%s\" not found!\r\n", "./id.ini");
			GetPrivateProfileString("ID","TOKEN_ID", "0", abTokenID, sizeof(abTokenID)-1, "./utils/id.ini");
		}
		dwTokenID = atoi(abTokenID);
		DBG("password = %s\r\n", password);
		DBG("dwTokenID = 0x%08x \"%s\"\r\n", dwTokenID, abTokenID);

		if (strlen(password) < 4 ||
			strlen(password) > 32) {
			sprintf(abMessage, "Incorrect password len!", dwRet);
			MessageBox(
				NULL,
				abMessage,
				"Incorrect password",
				MB_OK|MB_ICONSTOP
			);
			return 0;
		}

		// Connect
		dwRet = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &hContext);
		if (dwRet != SCARD_S_SUCCESS) {
			sprintf(abMessage, "SCardEstablishContext failed with error 0x%08x", dwRet);
			MessageBox(
				NULL,
				abMessage,
				"System error",
				MB_OK|MB_ICONSTOP
			);
			return 0;
		}
		i = 0;
		while (pabCartReadersNames[i]) {
			DBG("Connect to \"%s\"...\r\n", pabCartReadersNames[i]);
			dwRet = SCardConnect(hContext, (LPCSTR)pabCartReadersNames[i], SCARD_SHARE_SHARED,
				SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1 | SCARD_PROTOCOL_RAW,
				&hSmartCard, &dwActiveProtocol);
			if (dwRet != SCARD_S_SUCCESS) {
				goto next_reader;
			} else {
				if (dwActiveProtocol == SCARD_PROTOCOL_T0)  *pgpIOSendPCI = SCARD_PCI_T0;
				if (dwActiveProtocol == SCARD_PROTOCOL_T1)  *pgpIOSendPCI = SCARD_PCI_T1;
				if (dwActiveProtocol == SCARD_PROTOCOL_RAW) *pgpIOSendPCI = SCARD_PCI_RAW;
			}
			
			// Get ID:
			dwReplyLength = 256 + 2;
			dwRet = SCardTransmit(hSmartCard, *pgpIOSendPCI, pbyGetID, sizeof(pbyGetID), NULL, pbyOutput, &dwReplyLength);
			if (dwRet != SCARD_S_SUCCESS) {
				dwReplyLength = 0;
				sprintf(abMessage, "SCardTransmit failed with error 0x%08x, line = %d", dwRet, __LINE__);
				MessageBox(
					NULL,
					abMessage,
					"System error",
					MB_OK|MB_ICONSTOP
				);
				goto disconnect;
			}
			
			// Check ID:
			if (dwTokenID) {
				DWORD dwRealTokenID;
				dwRealTokenID = (((DWORD)pbyOutput[4]*256 + (DWORD)pbyOutput[5])*256 + (DWORD)pbyOutput[6])*256 + (DWORD)pbyOutput[7];
				DBG("ID = %d (%02x %02x %02x %02x) \r\n", dwRealTokenID, pbyOutput[4], pbyOutput[5], pbyOutput[6], pbyOutput[7]);
				
				if (dwRealTokenID != dwTokenID) {
					goto disconnect;
				}
			}
			
			// Found ok!
			bFoundFlag = 1;
			
			// Logout:
			dwReplyLength = 256 + 2;
			dwRet = SCardTransmit(hSmartCard, *pgpIOSendPCI, pbyLogout, sizeof(pbyLogout), NULL, pbyOutput, &dwReplyLength);
			if (dwRet != SCARD_S_SUCCESS) {
				dwReplyLength = 0;
				sprintf(abMessage, "SCardTransmit failed with error 0x%08x, line = %d", dwRet, __LINE__);
				MessageBox(
					NULL,
					abMessage,
					"System error",
					MB_OK|MB_ICONSTOP
				);
				goto disconnect;
			}
			
			// Login:
			memcpy(&pbyLogin[5], password, strlen(password));
			pbyLogin[4] = strlen(password);
			dwReplyLength = 256 + 2;
			dwRet = SCardTransmit(hSmartCard, *pgpIOSendPCI, pbyLogin, 5+pbyLogin[4], NULL, pbyOutput, &dwReplyLength);
			if (dwRet != SCARD_S_SUCCESS) {
				dwReplyLength = 0;
				sprintf(abMessage, "SCardTransmit failed with error 0x%08x, line = %d", dwRet, __LINE__);
				MessageBox(
					NULL,
					abMessage,
					"System error",
					MB_OK|MB_ICONSTOP
				);
				goto disconnect;
			}
			
			// Check login:
			if (dwReplyLength != 2 ||
				pbyOutput[0] != 0x90 ||
				pbyOutput[1] != 0x00) {
				sprintf(abMessage, "Incorrect password (ret = %02X%02X)!", pbyOutput[dwReplyLength-2], pbyOutput[dwReplyLength-1]);
				MessageBox(
					NULL,
					abMessage,
					"Error",
					MB_OK|MB_ICONSTOP
				);
				goto disconnect;
			}
			
			// Mount:
			dwReplyLength = 256 + 2;
			dwRet = SCardTransmit(hSmartCard, *pgpIOSendPCI, pbyMount, sizeof(pbyMount), NULL, pbyOutput, &dwReplyLength);
			if (dwRet != SCARD_S_SUCCESS) {
				dwReplyLength = 0;
				sprintf(abMessage, "SCardTransmit failed with error 0x%08x, line = %d", dwRet, __LINE__);
				MessageBox(
					NULL,
					abMessage,
					"System error",
					MB_OK|MB_ICONSTOP
				);
			} else
			if (dwReplyLength != 2 ||
				pbyOutput[0] != 0x90 ||
				pbyOutput[1] != 0x00) {
				sprintf(abMessage, "Cannot mount disk (ret = %02X%02X)!", pbyOutput[dwReplyLength-2], pbyOutput[dwReplyLength-1]);
				MessageBox(
					NULL,
					abMessage,
					"Error",
					MB_OK|MB_ICONSTOP
				);
			}
			
			// Logout:
			dwReplyLength = 256 + 2;
			dwRet = SCardTransmit(hSmartCard, *pgpIOSendPCI, pbyLogout, 8+2, NULL, pbyOutput, &dwReplyLength);
			if (dwRet != SCARD_S_SUCCESS) {
				dwReplyLength = 0;
				sprintf(abMessage, "SCardTransmit failed with error 0x%08x, line = %d", dwRet, __LINE__);
				MessageBox(
					NULL,
					abMessage,
					"System error",
					MB_OK|MB_ICONSTOP
				);
				goto disconnect;
			}
			
disconnect:
			// Disconnect:
			dwRet = SCardDisconnect(hSmartCard, 0);
			if (dwRet != SCARD_S_SUCCESS) {
				sprintf(abMessage, "SCardDisconnect failed with error 0x%08x", dwRet);
				MessageBox(
					NULL,
					abMessage,
					"System error",
					MB_OK|MB_ICONSTOP
				);
				SCardReleaseContext(hContext);
				return 0;
			} else {  
				dwRet = SCardReleaseContext(hContext);
				if (dwRet != SCARD_S_SUCCESS) {
					sprintf(abMessage, "SCardReleaseContext failed with error 0x%08x", dwRet);
					MessageBox(
						NULL,
						abMessage,
						"System error",
						MB_OK|MB_ICONSTOP
					);
					return 0;
				}
			}
next_reader:
			i++;
		}
		
		// null password!
		memset(password, 0, sizeof(password));
		
		if (bFoundFlag == 0) {
			sprintf(abMessage, "Token didn't found!", dwRet);
			MessageBox(
				NULL,
				abMessage,
				"System error",
				MB_OK|MB_ICONSTOP
			);
			return 0;
		}
		return 0;
	} else {
		//if (ret = 0xFFFFFFFF) {
		//	dwRet = GetLastError();
		//	sprintf(abMessage, "DialogBox return error 0x%08x!\r\n", dwRet);
		//	MessageBox(
		//		NULL,
		//		abMessage,
		//		"DialogBox() error!",
		//		MB_OK|MB_ICONSTOP
		//	);
		//} else 
		{
			DBG("DialogBox return = %08x\r\n", dwRet);
		}
	}

	return 0;
}
